/*             CSE 687 Final Project --- Pointer Class 
#####################################################################
#  This is the rewritten program of Project 3 "Sparse Matrix Class" #
#  with all pointers using Pointer Class                            #
#                                                                   #
#  Almost all member functions of Pointer class are used, except:   #
#   operator [], ++, --, >, <, >=, <=, and                          #
#   inquire member functions npointers(), psize()                   #
#                                                                   #
#  (some of the missing functions are tested in the main program)   #
#                                                                   #
#####################################################################

            Student Name: Gang Cheng SSN: 223-61-3010               */

/*******************************************************************
 * matrix.hh ---- header file for the module of the member & frind *
 *		  functions for class Matrix                       *
 *******************************************************************/

#ifndef Matrix_HH
#define Matrix_HH

#include <iostream.h>     // cin, cout, cerr
#include <stdlib.h>       // exit
#include <string.h>       // strlen, strcat, strcpy, strncpy 
#include "pointer.hh"     // Pointer class

// link list class 
struct llist {
	int id;          // connection node id
	double value;    // connection weight
	Pointer<llist> next;          // link to next connection list
	Pointer<llist> search(int id_index); // search for link-cell
      	void deallocate_llist(void);  // link-cells destructor 
};

// graph node class
struct node {
	int id;                       // node id
	Pointer<llist> link;          // link to connections
	Pointer<node> next;           // link to next node
	void deallocate_node(void);   // nodes destructor	
};

// Matrix class 
class Matrix {
   private:  
      int size;      // matrix size
      Pointer<llist> lptr;   // link list -- connection for nodes
      Pointer<node> nhead, nptr;  // top pointer & working pointer

   public:
      	// Matrix m[10]  - define arrays of objects	
	Matrix(void) { size = 0; lptr = NULL; nhead = nptr = NULL; } 
	Matrix(int msize);  // constructor
	Matrix(Matrix& m);  // Matrix m2 = m1 - copy constructor
	void deallocate_matrix();   // explicit matrix destructor
	~Matrix(void) { this->deallocate_matrix(); } // destructor
	// unary operator - m3 = m2 = m1	 
	Matrix& operator= (Matrix& m); 
	// binary operator + --- addition of two matrixes
	friend Matrix operator+ (Matrix& m1, Matrix& m2);
	// binary operator * --- multiplication of two matrixes 
	friend Matrix operator* (Matrix& m1, Matrix& m2);
 	// overloading istream operator >>
	friend istream& operator>> (istream& istrm, Matrix& m); 
 	// overloading ostream operator << 
	friend ostream& operator<< (ostream& ostrm, Matrix& m);
	int matrix_size(void) { return size; } // matrix size 
};	

#endif Matrix_HH
